Subject: Re: bad TSO performance in 2.6.9-rc2-BK

From: Andi Kleen <[email-masked]>
Date: Wed, 29 Sep 2004 01:55:34 +0200

On Tue, 28 Sep 2004 16:35:09 -0700
"David S. Miller" <[email-masked]> wrote:

> On Wed, 29 Sep 2004 01:27:57 +0200
> Andi Kleen <[email-masked]> wrote:
> 
> > I tried to re-test it but I didn't get very far because the kernel
> > with your patch crashes regularly during netperf. No serial console,
> > but the backtrace is {tcp_ack+877} {tcp_rcv_established+350} ... 
> > Before that there are a few "retrans out leaked" messages.
> 
> You might be missing the topmost part of the backtrace which is probably
> in tcp_clean_rtx_queue() or even more likely tcp_tso_acked() where there
> are several assertions present.
> 
> I guess your compiler is auto-inlining those functions for you,
> can you reproduce the crash with perhaps the noinline attribute
> added to those two functions I mention above so we can get a
> precise backtrace?

Hmpf, it stopped crashing after I recompiled without -funit-at-a-time
Maybe it is some compiler issue.

-Andi